#####################################################################################################
##
##      R tips and background helpful for solving ODEs in R
##      Kristan Reed, Cornell University
##
#####################################################################################################


#####################################################################################################
##
##      How to create your own function using the function()
##
#####################################################################################################
## The basic syntax is : FunctionName = function(arguments){function statement}


## Create an example function to multiply two numbers together

    multiply = function(x, y){ ##model inputs are given in the parentheses
      ## Model 
       z=x*y
    }

      ## The function above is technically complete. Try it out. What happens? 
      
      
      
      
      
      ## If you ran something like 
      
      multiply(65, 72)
      
      ## you might be confused because it appears like nothing is happening
      ## This is because the function does not include a return function.
      ## The multiply function is still performing the intended job, however
      ## it does not print the result because it has stored it in a temporary
      ## variable called z. If you remove 'z=' from the statement above, what happens?
      
      multiply2 = function(x, y){ ##model inputs are given in the parentheses
        ## Model 
        x*y
      }
      
      multiply2(45,61)
      
      ## now it prints because the default multiplication operation includes a print statement
      ## However, it can be really helpful to create temporary variables within functions so
      ## if your desired output is stored in a temporary variarble all you need to do is add a 
      ## return statement to the function
      
      multiply = function(x, y){ ##model inputs are given in the parentheses
        ## Model 
        z=x*y
        return(z)
      }


## Create your own function to test your new skill
      
      
      
      