#**************************************************#
#R tutorial for 2021 NANP Nutrition Models Workshop#
#**************************************************#
#Tim Hackmann
#University of California, Davis

###############################
#Perform some basic operations#
###############################
#Perform simple addition
#Run by placing cursor on line below, then clicking "Run"
a=2+2

#Output the result
print(a)

###############################################################
#Prepare R for bigger and better things by installing packages#
###############################################################
#Download and install the package
install.packages("ggplot2")

#Load the package
library(ggplot2)

#Make a plot with the package
ggplot(data = mtcars, mapping = aes(x = wt, y = mpg)) + geom_point() 

#######################################
#Get practice reading in external data#
#######################################
#Switch working directory to location of data
#Replace C:/My Directory/" with the actual directory name
setwd("C:/My Directory")

#Read in data
mtcars_local <- read.csv(file="R tutorial--data file.csv", header=TRUE, sep=",")

#Make a plot with the data
ggplot(data = mtcars_local, mapping = aes(x = wt, y = mpg)) + geom_point() 

#################
#Manipulate data#
#################
#Calculate weight on moon (wt_moon)
wt_multiplier = 0.165188131 #Ratio of weight on moon to weight on earth
mtcars_local$wt_moon = mtcars_local$wt*wt_multiplier

#View data with wt_moon added
mtcars_local

#Plot new data
ggplot(data = mtcars_local, mapping = aes(x = wt_moon, y = mpg)) + geom_point()

#####################################
#Download packages for the exercises#
#####################################
install.packages("boot")
install.packages("caret")
install.packages("readr")
install.packages("summarytools")
install.packages("reshape2") 
install.packages("png")
install.packages("plyr")
install.packages("parallel")
install.packages("lme4") 
install.packages("MuMIn") 
install.packages("lmerTest")
install.packages("sjlabelled")
install.packages("sjmisc")
install.packages("sjstats")
install.packages("ggeffects")
install.packages("rlang")
install.packages("sjPlot")
install.packages("deSolve") 
install.packages("FME") 
install.packages("ggplot2")
install.packages("gridExtra")